import React, { createContext, useState, useEffect } from 'react';
import * as serviceWorker from './sw.config';
/**@type {React.FC<{test: boolean;config: {  swUrl: string;  onUpdate: (registration: ServiceWorkerRegistration) => void;  onSuccess: (registration: ServiceWorkerRegistration) => void;  onError: () => void;  onOffline: () => void; }}>} --*/

var ReactPwa = function ReactPwa(props) {
  var _useState = useState(false),
      reg = _useState[0],
      setReg = _useState[1];

  useEffect(function () {
    if (!serviceWorker.isLocalhost || props.test) {
      serviceWorker.register(props.config).then(function (e) {
        return setReg(e);
      });
    }
  }, [props]);
  return /*#__PURE__*/React.createElement(PwaCtx.Provider, {
    value: CreatePWA(reg),
    children: props.children
  });
};
/**@returns {{isInstalled: "web" | "standalone";installApp(): void;supportsPWA: boolean}} --*/


export var usePwa = function usePwa() {
  var _React$useContext = React.useContext(PwaCtx),
      isInstalled = _React$useContext[0],
      installApp = _React$useContext[1],
      supportsPWA = _React$useContext[2];

  return {
    isInstalled: isInstalled,
    installApp: installApp,
    supportsPWA: supportsPWA
  };
};
/**@type {React.Context<[isInstalled: "web"|"standalone", promptInstall: function, supportsPwa: boolean]>} --*/

export var PwaCtx = createContext();

var CreatePWA = function CreatePWA() {
  /**
   * @type {[string: "web"|"standalone", React.Dispatch<React.SetStateAction<"web"|"standalone">> ]} 
   */
  var _useState2 = useState("web"),
      isInstalled = _useState2[0],
      setIsInstalled = _useState2[1];
  /**
   * @type {[ Event & { 
   *      prompt(): Promise<void> ,
   *      readonly userChoice: Promise<{
   *          outcome: 'accepted' | 'dismissed',
   *          platform: string
   *      }>;
   *  }, React.Dispatch<React.SetStateAction<{}>>],
   * } 
   */


  var _useState3 = useState(null),
      promptInstall = _useState3[0],
      setPromptInstall = _useState3[1];

  var _useState4 = useState(false),
      supportsPWA = _useState4[0],
      setSupportsPWA = _useState4[1];
  /**@param {Event} evt */


  function onClickInstall(evt) {
    try {
      if (evt && evt.preventDefault) {
        evt.preventDefault();
      }

      return promptInstall.prompt();
    } catch (error) {
      console.error('[catch promptInstall]', {
        error: error
      });
    }
  }

  ;
  React.useEffect(function () {
    if ('serviceWorker' in navigator) {
      setSupportsPWA(true);
      window.addEventListener("beforeinstallprompt", setPromptInstall);
      return function () {
        window.removeEventListener("beforeinstallprompt");
      };
    }

    ;
  }, []);
  React.useEffect(function () {
    if (window) {
      if (window.matchMedia('(display-mode: standalone)').matches) setIsInstalled('standalone');
      window.addEventListener('appinstalled', function () {
        return setIsInstalled('standalone');
      });
      return function () {
        window.removeEventListener("appinstalled");
      };
    }
  }, []);
  return [isInstalled, onClickInstall, supportsPWA];
};

export default ReactPwa;