"use strict";

exports.__esModule = true;
exports["default"] = exports.PwaCtx = exports.usePwa = void 0;

var _react = _interopRequireWildcard(require("react"));

var serviceWorker = _interopRequireWildcard(require("./sw.config"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**@type {React.FC<{test: boolean;config: {  swUrl: string;  onUpdate: (registration: ServiceWorkerRegistration) => void;  onSuccess: (registration: ServiceWorkerRegistration) => void;  onError: () => void;  onOffline: () => void; }}>} --*/
var ReactPwa = function ReactPwa(props) {
  var _useState = (0, _react.useState)(false),
      reg = _useState[0],
      setReg = _useState[1];

  (0, _react.useEffect)(function () {
    if (!serviceWorker.isLocalhost || props.test) {
      serviceWorker.register(props.config).then(function (e) {
        return setReg(e);
      });
    }
  }, [props]);
  return /*#__PURE__*/_react["default"].createElement(PwaCtx.Provider, {
    value: CreatePWA(reg),
    children: props.children
  });
};
/**@returns {{isInstalled: "web" | "standalone";installApp(): void;supportsPWA: boolean}} --*/


var usePwa = function usePwa() {
  var _React$useContext = _react["default"].useContext(PwaCtx),
      isInstalled = _React$useContext[0],
      installApp = _React$useContext[1],
      supportsPWA = _React$useContext[2];

  return {
    isInstalled: isInstalled,
    installApp: installApp,
    supportsPWA: supportsPWA
  };
};
/**@type {React.Context<[isInstalled: "web"|"standalone", promptInstall: function, supportsPwa: boolean]>} --*/


exports.usePwa = usePwa;
var PwaCtx = (0, _react.createContext)();
exports.PwaCtx = PwaCtx;

var CreatePWA = function CreatePWA() {
  /**
   * @type {[string: "web"|"standalone", React.Dispatch<React.SetStateAction<"web"|"standalone">> ]} 
   */
  var _useState2 = (0, _react.useState)("web"),
      isInstalled = _useState2[0],
      setIsInstalled = _useState2[1];
  /**
   * @type {[ Event & { 
   *      prompt(): Promise<void> ,
   *      readonly userChoice: Promise<{
   *          outcome: 'accepted' | 'dismissed',
   *          platform: string
   *      }>;
   *  }, React.Dispatch<React.SetStateAction<{}>>],
   * } 
   */


  var _useState3 = (0, _react.useState)(null),
      promptInstall = _useState3[0],
      setPromptInstall = _useState3[1];

  var _useState4 = (0, _react.useState)(false),
      supportsPWA = _useState4[0],
      setSupportsPWA = _useState4[1];
  /**@param {Event} evt */


  function onClickInstall(evt) {
    try {
      if (evt && evt.preventDefault) {
        evt.preventDefault();
      }

      return promptInstall.prompt();
    } catch (error) {
      console.error('[catch promptInstall]', {
        error: error
      });
    }
  }

  ;

  _react["default"].useEffect(function () {
    if ('serviceWorker' in navigator) {
      setSupportsPWA(true);
      window.addEventListener("beforeinstallprompt", setPromptInstall);
      return function () {
        window.removeEventListener("beforeinstallprompt");
      };
    }

    ;
  }, []);

  _react["default"].useEffect(function () {
    if (window) {
      if (window.matchMedia('(display-mode: standalone)').matches) setIsInstalled('standalone');
      window.addEventListener('appinstalled', function () {
        return setIsInstalled('standalone');
      });
      return function () {
        window.removeEventListener("appinstalled");
      };
    }
  }, []);

  return [isInstalled, onClickInstall, supportsPWA];
};

var _default = ReactPwa;
exports["default"] = _default;